###
### Hydrogen by h2@efnet (htwo@geocities.com)
###
### email me with any bug reports and stuff
###
###
### special thanks to:
###   Coolio, dianep, SideWnder, StephenC, and the #XiRCON bar & grill
###




##################
### DONT TOUCH ###
##################

set hver 1.0a2
set doingwhois 0
set showingwhois 0

menu status "-=\[ Settings for Hydrogen \]=-"
menu status ""
menu status "Incoming Message Beep" { /set msgbeep [prompt "Incoming Message Beep" "Enter 1 for yes, 0 for no"] }
menu status "Incoming Notice Beep" { /set noticebeep [prompt "Incoming Notice Beep" "Enter 1 for yes, 0 for no"] }
menu status "Default User Mode" { /set defaultusermode [prompt "Default User Mode"] }
menu status ""
menu status "Autojoin->On/Off" { /set autojoin [prompt "Autojoin" "Enter 1 for yes, 0 for no"] }
menu status "Autojoin->Channels" { /set autochans [prompt "Autojoin Channels" "Separate channels by a space"] }

alias SET {
	switch -exact [string tolower [lindex [args] 0]] {
	"msgbeep" {
		set_cookie msgBeep [lindex [args] 1]
		echo "[h2echo] Incoming message beep is now set."
		set msgBeep [lindex [args] 1]
		}
	"noticebeep" {
		set_cookie noticeBeep [lindex [args] 1]
		echo "[h2echo] Incoming notice beep is now set."
		set noticeBeep [lindex [args] 1]
		}
	"autojoin" {
		set_cookie autoJoin [lindex [args] 1]
		echo "[h2echo] Autojoin is now set."
		set autoJoin [lindex [args] 1]
		}
	"autochans" {
		set_cookie autoChans [lrange [args] 1 end]
		echo "[h2echo] Autojoin channels set to: [lrange [args] 1 end]"
		set autoChans [lrange [args] 1 end]
		}
	"defaultusermode" {
		set_cookie defaultUserMode [lindex [args] 1]
		echo "[h2echo] Default user mode set to: [lindex [args] 1]"
		set defaultUserMode [lindex [args] 1]
		}
	}
	complete
}

if ![info exists tab_list] {set tab_list ""}
set completionList ""
set completionIdx 0
set lastPartial ""
set lastMatch ""
set msgBeep [get_cookie msgBeep 1]
set noticeBeep [get_cookie noticeBeep 1]
set autoJoin [get_cookie autoJoin 1]
set autoChans [get_cookie autoChans "#XiRCON"]
set defaultUserMode [get_cookie defaultUserMode "+i"]

##################
### DONT TOUCH ###
##################




### Aliases

alias j {
    if {[string index [args] 0] == "#" || [string index [args] 0] == "&"} {
        /join [join [args]]
        complete
    } {
        /join #[join [args]]
        complete
    }
}
alias p {
    /part [join [args]]
    complete
}
alias m {
    /msg [join [args]]
    complete
}
alias w {
    /who [join [args]]
    complete
}
alias wi {
    /whois [join [args]]
    complete
}
alias ww {
    /whowas [join [args]]
    complete
}
alias ping {
    /ctcp [join [args]] PING
    complete
}
alias ver {
    /ctcp [join [args]] VERSION
    complete
}
alias me {
    set n [window name]
    /ctcp $n ACTION [raw_args]
    echo "[color action]* [my_nick] [join [args]]" [window type] $n
    complete
}
alias ame {
    foreach c [channels] {
        /ctcp $c ACTION [raw_args]
        echo "[color action]* [my_nick] [join [args]]" [window type] $c
        complete
    }
}
alias ctcp {
    set type [string tolower [lindex [args] 1]]
    if {$type != "action"} {
        echo "[color ctcp]-> \[[lindex [args] 0]\] [string toupper [lrange [raw_args] 1 end]]"
    }
}
alias tcl {
    catch {eval [join [args]]} var
    if {($var != "0") && ($var != "1") && ($var != "")} {
        echo "[color error]*** Tcl Error:[color public] $var"
    }
    complete
}
alias privmsg {
    set nick [lindex [args] 0]
    if {$nick != [channel]} {
    iremoveFromList completionList $nick
    set completionList [linsert $completionList 0 $nick]
    }
}
alias whois {
    set doingwhois 1
    /raw WHOIS [join [args]]
    complete
}
alias away {
	set text [join [args]]
	set_cookie awaySince [clock seconds]
	if {$text != ""} {
		/ame is away... $text [hydro]
		/raw AWAY :$text [hydro]
		complete
	} {
		/ame is away... [hydro]
		/raw AWAY :not here right now [hydro]
		complete
	}
}
alias back {
	set awayTime [tconv [expr [clock seconds] - [get_cookie awaySince]]]
	/ame has returned from the dead. gone $awayTime
	/raw AWAY
	complete
}
alias quit {
	set text [join [args]]
	if {$text != ""} {
		/raw QUIT :hydrogen: $text
	} {
		/raw QUIT :-hydrogen-
	}
}
alias send {
	set nick [lindex [join [args]] 0]
	set file [lindex [join [args]] 1]
	/dcc send $nick $file
	complete
}
alias chat {
	set nick [lindex [join [args]] 0]
	/dcc chat $nick
	complete
}

### Events

on connect {
    /mode [my_nick] $defaultUserMode
	if {$autoJoin} {
    	foreach aC $autoChans {
        	/j $aC
        	complete
    	}
	}
}
on privmsg {
  set recp [string tolower [lindex [args] 0]]
  if {$recp == [string tolower [my_nick]] || [string match *@* $recp] && ![string match #* $recp] && ![string match &* $recp] && ![string match +* $recp] && ![string match \$* $recp]} {
    xecho "[color ctcp]\[[color change][nick]([user]@[host])[color ctcp]\][color public] [join [lrange [args] 1 end]]"
    if {$msgBeep} { beep }
    add_tab [nick]
    complete
  }
}
on privmsg {
    if {[sCompare [lindex [args] 0] [my_nick]]} {
    set nick [lindex [args] 0]
    iremoveFromList completionList $nick
    set completionList [linsert $completionList 0 $nick]
    }
}
on notice {
  set recp [string tolower [lindex [args] 0]]
  if {$recp == [string tolower [my_nick]] || [string match *@* $recp] && ![string match #* $recp] && ![string match &* $recp] && ![string match +* $recp] && ![string match \$* $recp]} {
    xecho "[color ctcp]-[color change][nick]([user]@[host])[color ctcp]-[color notice] [join [lrange [args] 1 end]]"
    if {$noticeBeep} { beep }
    add_tab [nick]
    complete
  }
}
on ctcp {
    set type [string tolower [lindex [args] 1]]
    if {$type == "sound"} { complete }
    if {$type != "action" && $type != "dcc"} {
        if {$type == "version"} {
            /raw notice [nick] :VERSION hydrogen $hver by h2
            echo "[color ctcp]*** CTCP VERSION request by [color nick][nick][color ctcp]."
            complete
        } {
            echo "[color ctcp]*** CTCP [string toupper $type] request by [color nick][nick][color ctcp]."
        }
    } {
        if {$type == "action"} {
            if {[string match "#*" [lindex [join [args]] 0]]} {
                echo "[color action]* [nick] [lrange [join [args]] 2 end]" channel [lindex [join [args]] 0]
            }
            if {![string match "#*" [lindex [join [args]] 0]]} {
                echo "[color action]* [nick] [lrange [join [args]] 2 end]" query [lindex [join [args]] 0]
            }
            complete
        }
    }
}
on ctcp_reply {
    set nick [nick]
    set type [lindex [args] 1]
    set reply [lrange [join [args]] 2 end]
    if {$type == "PING"} {
        echo "[color ctcp]*** CTCP PING reply from [color nick]$nick[color ctcp]:[color public] [tconv [expr [clock seconds] - [lindex $reply 0]]]"
        complete
    } {
        echo "[color ctcp]*** CTCP $type reply from [color nick]$nick[color ctcp]:[color public] $reply"
        complete
    }
}
on 311 {
    if {$doingwhois} {
        set showingwhois 1
        echo "[color ctcp]([color change]whois[color ctcp]\)" [window type] [window name]
        echo "[color ctcp] [color nick][lindex [args] 1][color public] is [color nick][lindex [args] 2]@[lindex [args] 3] \([lrange [join [args]] 5 end]\)" [window type] [window name]
        complete
    }
}
on 319 {
    if {$doingwhois && $showingwhois} {
        echo "[color ctcp] [color nick]on channels:[color mode] [lrange [join [args]] 2 end]" [window type] [window name]
        complete
    }
}
on 312 {
    if {$doingwhois && $showingwhois} {
        echo "[color ctcp] [color nick]on IRC via [color mode][lindex [args] 2] \([lrange [join [args]] 3 end]\)" [window type] [window name]
        complete
    }
}
on 301 {
    if {$doingwhois && $showingwhois} {
        echo "[color ctcp] [color nick][lindex [args] 1] is away: [color mode][lrange [join [args]] 2 end]" [window type] [window name]
        complete
    } {
        echo "[color error]***[color public] [lindex [args] 1] is currently set away." status
        complete
    }
}
on 313 {
    if {$doingwhois && $showingwhois} {
        echo "[color ctcp] [color nick][lindex [args] 1] is an IRC Operator." [window type] [window name]
        complete
    }
}
on 317 {
    if {$doingwhois && $showingwhois} {
        echo "[color ctcp] [color nick]idle [tconv [lindex [args] 2]]" [window type] [window name]
        complete
    }
}
on 318 {
    if {$doingwhois && $showingwhois} {
        set doingwhois 0
        set showingwhois 0
        echo "[color ctcp]" [window type] [window name]
        complete
    }
}

### Procs

proc len {str} {return [string length $str]}
proc nickcomplete {partial {repeatLast 0}} {
    global completionList
    global completionIdx
    global lastPartial
    global lastMatch
    set cl [resetCompletionList]
    if {$repeatLast} {
    incr completionIdx
    if {$completionIdx >= [llength $cl]} {
        set completionIdx 0
    }
    set cl [lrange $cl $completionIdx end]
        set partial $lastPartial
    } else {
    set completionIdx 0
    }
    
    
    set lastPartial $partial
    
    set idx [ilsearch $cl "${partial}*"]
    set completionIdx [expr $completionIdx + $idx]
    
    if {$idx == -1} {
    set completionIdx 0
    set cl [resetCompletionList]
    set idx [ilsearch $cl "${partial}*"]
    set completionIdx [expr $completionIdx + $idx]
    }
    
    set lastMatch [lindex $cl $idx]
    return $lastMatch
}
proc resetCompletionList {} {
    global completionList
    set cl $completionList
    if {[window_type] == "channel"} {
    foreach nick [nicks [channel]] {
        set n [string trimleft $nick "@+"]
        lappend cl $n
    }
    }
    return $cl
}
proc ilsearch {list item} { 
    set idx 0
    foreach i $list {
        if {[sCompare $item $i]} {
            return $idx
        }
        incr idx
    }
    return -1
}
proc sCompare {a b} {
    return [string match [string tolower $a] [string tolower $b]]
}
proc iremoveFromList {list element} {
    upvar $list mylist
    set i [ilsearch $mylist $element]
    if {$i > -1} {set mylist [lreplace $mylist $i $i]} 
}
proc xecho {msg} {echo $msg [window_type] [window_name]}
proc add_tab {nickname} {
  global tab_list
  if {[lsearch -exact [string tolower $tab_list] [string tolower $nickname]] != -1} {
    set tab_list [lreplace $tab_list [lsearch -exact [string tolower $tab_list] [string tolower $nickname]] [lsearch -exact [string tolower $tab_list] [string tolower $nickname]]]
  }
  if {$tab_list == "\{\}"} {set tab_list ""}
  lappend tab_list $nickname
}
proc get_tab {} {
  global  tab_list
  set firstnick [lindex $tab_list 0]
  set tab_list  [lrange $tab_list 1 4]
  if {$tab_list == "\{\}"} {set tab_list ""}
  lappend tab_list $firstnick
  # bamboozles the tab_list selection back one, giving the neatospiffywow
  # 'toggle' effect to the whole thing
  return $firstnick
}
proc get_next_tab {} {
  set nickname [get_tab]
  if {$nickname == ""} {
    input set_text "/msg "
    input set_sel_start 5
  } else {
    input set_text "/msg $nickname "
    input set_sel_start [expr [string length $nickname] + 6]
  }
  complete
}
proc tconv {thetime} {
  set years ""
  set months ""
  set weeks ""
  set days ""
  set hours ""
  set minutes ""
  set seconds ""
  if { [expr $thetime >= 31536000] == 1 } {
    set years [expr int($thetime/31536000)]
    set thetime [expr $thetime-(31536000*$years)]
    if { $years > 1 } { set years [concat $years "years"] } else { set years [concat $years "year"] }
  }
  if { [expr $thetime >= 2592000] == 1 } {
    set months [expr int($thetime/2592000)]
    set thetime [expr $thetime-(2592000*$months)]
    if { $months > 1 } { set months [concat $months "months"] } else { set months [concat $months "month"] }
  }
  if { [expr $thetime >= 604800] == 1 } {
    set weeks [expr int($thetime/604800)]
    set thetime [expr $thetime-(604800*$weeks)]
    if { $weeks > 1 } { set weeks [concat $weeks "weeks"] } else { set weeks [concat $weeks "week"] }
  }
  if { [expr $thetime >= 86400] == 1 } {
    set days [expr int($thetime/86400)]
    set thetime [expr $thetime-(2592000*$days)]
    if { $days > 1 } { set days [concat $days "days"] } else { set days [concat $days "day"] }
  }
  if { [expr $thetime >= 3600] == 1 } {
    set hours [expr int($thetime/3600)]
    set thetime [expr $thetime-(3600*$hours)]
    if { $hours > 1 } { set hours [concat $hours "hours"] } else { set hours [concat $hours "hour"] }
  }
  if { [expr $thetime >= 60] == 1 } {
    set minutes [expr int($thetime/60)]
    set thetime [expr $thetime-(60*$minutes)]
    if { $minutes > 1 } { set minutes [concat $minutes "minutes"] } else {set minutes [concat $minutes "minute"] }
  }
  if { [expr $thetime < 60] == 1 } {
    if {$thetime > 0} {
    set seconds $thetime
    if { $seconds > 1 } { set seconds [concat $seconds "seconds"] } else {set seconds [concat $seconds "second"] }
    }
  }
  set idle [concat $years $months $weeks $days $hours $minutes $seconds]
  return "$idle"
  complete
}
proc hydro {} { return \[hydrogen\] }
proc h2echo {} { return [color change]\[hydrogen\][color public] }

### Hotkeys

hotkey tab {
    set a ""
    set b ""
    set c ""
    set text [input get_text]
    set start [input get_sel_start]
    set length [input get_sel_length]
    regexp -nocase {(.* +)?([^ ]+ *$)} $text a b c
    set c [string trim $c]
    set c [string trim $c :]
    set b [string trim $b]
    if {$c == $lastMatch} {
    set output [nickcomplete $lastPartial 1]
    } else {
    set output [nickcomplete $c 0]
    }
    
    if {$output == ""} {complete;return}
    
    if {$b == ""} {
        set output "$output: "
    } else {
    set output "${b} $output"
    }
    
    input set_text $output
    input set_sel_start [string length $output]
    input set_sel_length $length
    complete
}
hotkey F12 get_next_tab

### Menus

menu channel "*Channel Information" { show_props channel [join [args]] }